/*
        $Id$

        Copyright (C) 2000 Syllabub
        Maroontress Fast Software.
*/

typedef void (*ResizeNotifier)(void *, int, int, int);

typedef struct PreeditStringPainter {
    Display *disp;
    Window window;
    GC gc;
    Pixmap pixmap;
    SylFontSet fontset;
    int width;
    int height;
    int depth;
    int sidemargin;
    unsigned long *pixel;

    SylFontSet user_fontset;
    unsigned long user_fg;
    unsigned long user_bg;

    SylText *string;
    unsigned long *feedback;
    int n_feedbacks;
    int caret;
    int redraw;

    ResizeNotifier cb_func;
    void *cb_data;
} PreeditStringPainter;

PreeditStringPainter * CreatePreeditStringPainter(Display *disp, Window parent,
						  char *component,
						  ResizeNotifier callback,
						  void *callback_data);
void FreePreeditStringPainter(PreeditStringPainter *);
void SendPreeditStringPainter(PreeditStringPainter *, XEvent *);
int NicePreeditStringPainter(PreeditStringPainter *);

void MovePreeditStringPainter(PreeditStringPainter *, int, int);
void SetWCStringPreeditStringPainter(PreeditStringPainter *, wchar_t *);
void SetMBStringPreeditStringPainter(PreeditStringPainter *, char *);
void SetFeedbackPreeditStringPainter(PreeditStringPainter *,
				     unsigned long *, int);
void SetCaretPositionPreeditStringPainter(PreeditStringPainter *, int);
void SetFontsetPreeditStringPainter(PreeditStringPainter *, char *);

void SetForegroundPreeditStringPainter(PreeditStringPainter *, unsigned long);
void SetBackgroundPreeditStringPainter(PreeditStringPainter *, unsigned long);
